import java.util.ArrayList;
import java.util.HashMap;

/**
 * A simple command line parser.
 * Options are expressed as "-o" or "-o:<value>" like using javac.
 * 
 * @author Klaus Berg
 */
public final class ArgumentParser extends Object {

    private ArrayList params = new ArrayList(10);
    private HashMap options = new HashMap(13);
    private int paramIndex = 0;

    public ArgumentParser(String args[]) {
        for (int i=0; i<args.length; i++) {
            if (args[i].startsWith("-")) {
                int location = args[i].indexOf(":");
                String key = (location > 0) ? args[i].substring(1, location) : args[i].substring(1);
                String value = (location > 0) ? args[i].substring(location+1) : "";
                options.put(key, value);
            }
            else {
                params.add(args[i]);
            }
        }
    }

    public boolean hasOption(String opt) {
        return options.containsKey(opt.toLowerCase());
    }

    public String getOption(String opt) {
        return (String)options.get(opt.toLowerCase());
    }

    public String nextParam() {
        if (paramIndex < params.size()) {
            return (String)params.get(paramIndex++);
        }
        else {
            return null;
        }
    }    
}
